// JSTOJ.java

// This program constructs an applet with A GUI and all necessary logic for
// displaying a message on a colored background.

import java.awt.*;
import java.applet.Applet;

// ==========================================================================
// Class: JSTOJ
//
// This class is the main (and only) class for the JSTOJ applet. Even though
// field msg and methods init(), paint(), and setColor() are all public, only
// msg and setColor() should be accessed from JavaScript.
// ==========================================================================

public class JSTOJ extends Applet
{
   // The following variable identifies the message to be displayed.

   public String msg = System.getProperty ("java.version"); 

   // ==================================================================
   // Method: init()
   //
   // Initialize the applet by drawing msg's text on a black background.
   //
   // Arguments:
   // 
   // none
   //
   // Return:
   //
   // nothing
   // ==================================================================

   public void init ()
   {
      setColor ("black");
   }

   // ===================================
   // Method: paint()
   //
   // Paint the applet's drawing surface.
   //
   // Arguments:
   // 
   // g - graphics context
   //
   // Return:
   //
   // nothing
   // ===================================

   public void paint (Graphics g)
   {
      // Obtain the width and height of the applet's drawing surface.

      int w = getSize ().width;
      int h = getSize ().height;

      // Paint applet's drawing surface using current foreground color.

      g.fillRect (0, 0, w, h);

      // Calculate the coordinates of the text baseline so that the message
      // appears centered whe drawn.

      FontMetrics fm = g.getFontMetrics ();
      int x = (w - fm.stringWidth (msg)) / 2;
      int y = (h - fm.getHeight ()) / 2;

      // Change the foreground color to white and draw the message in this
      // color.

      g.setColor (Color.white);
      g.drawString (msg, x, y);
   }

   // ====================================================================
   // Method: setColor()
   //
   // Set the applet's foreground drawing color and call repaint() to 
   // indirectly paint its drawing surface.
   //
   // Arguments:
   // 
   // color - name of foreground color (must be red, green, blue or black)
   //
   // Return:
   //
   // nothing
   // ====================================================================

   public void setColor (String color)
   {
      if (color.equals ("red"))
          setForeground (Color.red);
      else
      if (color.equals ("magenta"))
          setForeground (Color.magenta);
      else
      if (color.equals ("blue"))
          setForeground (Color.blue);
      else
          setForeground (Color.black);

      repaint ();
   }
}
