// JTOJS.java

// This program constructs an applet whose only purpose is to call the
// JavaScript script that contains a "callFromJava()" function.

import netscape.javascript.JSObject;

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

// =============================================================
// Class: JTOJS
//
// This class is the main (and only) class for the JTOJS applet.
// =============================================================

public class JTOJS extends Applet
{
   // =============================================
   // Method: init()
   //
   // Initialize the applet by creating simple GUI.
   //
   // Arguments:
   // 
   // none
   //
   // Return:
   //
   // nothing
   // =============================================

   public void init ()
   {
      // Set the background color to cyan, for aesthetic reasons.

      setBackground (Color.cyan);

      // Organize GUI components in a Panel.

      Panel p = new Panel ();

      // Create an informative Label.

      Label l = new Label ("Enter a message (and press Enter):");

      // Establish a matching background color for Label.

      l.setBackground (Color.cyan);

      // Add Label to Panel.

      p.add (l);

      // Create a TextField for data entry.

      final TextField t = new TextField (20);

      // Create action listener to respond to Enter being pressed. In
      // response, send contents of TextField to JavaScript.

      ActionListener al;
      al = new ActionListener ()
           {
               public void actionPerformed (ActionEvent e)
               {
                  // Prepare array of arguments for call to JavaScript.

                  Object [] args = { t.getText () };

                  // Obtain the browser window in which this applet is
                  // displayed.

                  JSObject window = JSObject.getWindow (JTOJS.this);

                  // Call the JavaScript "callFromJava()" function and pass
                  // args to this function.

                  window.call ("callFromJava", args);
               }
           };
      t.addActionListener (al);

      // Add TextField to Panel.

      p.add (t);

      // Add Panel to applet.

      add (p);
   }
}
